<template>
    <div class="box-create">
        <form action="" method="POST" @submit.prevent="submit">
            <p class="text-podskazka"><span>*</span>{{ $t('currencies.form.required_help') }}</p>
            <div class="create__input">
                <label for="form_name"><span>*</span>{{ $t('currencies.form.name') }}</label>
                <div class="input__svg">
                    <input type="text" required v-model="form.name" id="form_name" name="name"/>
                    <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                </div>
            </div>
            <div class="create__input">
                <label for="form_symbol"><span>*</span>{{ $t('currencies.form.symbol') }}</label>
                <div class="input__svg">
                    <input type="text" required v-model="form.symbol" id="form_symbol" name="symbol"/>
                    <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                </div>
            </div>
            <div class="create__input">
                <label for="form_code"><span>*</span>{{ $t('currencies.form.code') }}</label>
                <div class="input__svg">
                    <input type="text" required v-model="form.code" id="form_code" name="code"/>
                    <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                </div>
            </div>
            <div class="create__input">
                <label for="form_code_iso"><span>*</span>{{ $t('currencies.form.code_iso') }}</label>
                <div class="input__svg">
                    <input type="text" required v-model="form.code_iso" id="form_code_iso" name="code_iso"/>
                    <tooltip :info="$t('currencies.form.code_iso_help')"/>
                </div>
            </div>
            <div class="create__input rate__input__box" v-for="target_currency in target_currencies" v-if="form.rates[target_currency.id]">
                <label :for="`form_rate_${target_currency.code_iso}`"><span>*</span>{{ $t('currencies.form.rate') }} {{ target_currency.code_iso }}:</label>
                <div class="input__svg input__rate">
                    <input type="text" required
                           :id="`form_rate_${target_currency.code_iso}`"
                           v-model.number="form.rates[target_currency.id].rate"
                           :name="`rate_${target_currency.code_iso}`"/>
                </div>
                <div class="input__rate__fixed">
                    <rate-checkbox :false-value="'api'" :true-value="'fixed'"
                                    v-model="form.rates[target_currency.id].type" width="10%"></rate-checkbox>
                    <tooltip :info="$t('currencies.form.rate_fixed_help')"/>
                </div>
            </div>
            <div class="create-check">
                <div class="check__left">
                    <p class="text-check">{{ $t('currencies.form.auto_update') }}</p>
                    <toggle v-model="form.auto_update_rate" name="auto_update_rate"/>
                </div>
                <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
            </div>

            <button type="submit" style="margin-top: 30px;">{{ $t('currencies.form.submit') }}</button>
        </form>
    </div>
</template>

<script>
    import currencies from "../../currencies";
    import RateCheckbox from "./RateCheckbox";

	export default {
		name: "CurrencyForm",
        props: ['currency'],
        data(){
		    return {
		        form: {
                    name: '',
                    symbol: '',
                    code: '',
                    code_iso: '',
                    auto_update_rate: 0,
                    rates: {}
                }
            }
        },
        computed: {
		    rates(){
                let rates = {};
                if(this.currency && this.currency.id){
                    _.each(this.target_currencies, currency => {
                        console.log(currency);
                        let pair = _.find(currencies.rates, {
                            currency_id: this.currency.id,
                            target_currency_id: currency.id
                        });
                        if(pair){
                            rates[currency.id] = {
                                rate: pair.rate,
                                type: pair.type
                            }
                        }else{
                            rates[currency.id] = {
                                rate: 0,
                                type: 'api'
                            }
                        }
                    });
                }else{
                    _.each(this.target_currencies, currency => {
                        rates[currency.id] = {
                            rate: 0,
                            type: 'api'
                        }
                    });
                }
                return rates;
            },
            target_currencies(){
		        return this.currency && this.currency.id ? _.filter(currencies.currencies, currency => currency.id !== this.currency.id) : currencies.currencies;
            }
        },
        watch: {
		    currency(currency){
                this.form = currency;
                setTimeout(() => {
                    this.$set(this.form, 'rates', this.rates);
                }, 200);
            }
        },
        methods: {
            submit(){
                this.$emit('submit', this.form);
            },
        },
        components: {
		    RateCheckbox
        },
        mounted(){
		    if(this.currency){
		        this.form = this.currency;
            }
            console.log(this.rates);
            setTimeout(() => {
                console.log(this.rates);
                this.$set(this.form, 'rates', this.rates);
            }, 200);
        }
	}
</script>

<style scoped lang="scss">
    .create-tarif .box-create form .rate__input__box{
        justify-content: start;
        label{
            flex-basis: 38%;
        }
        .input__rate{
            flex-basis: 52%;
        }
    }
    .create-tarif .box-create form .create__input .input__rate, .input__rate{
        flex-basis: 39.5%;
        input {
            width: calc(393px - 15px);
        }
    }
    .input__rate__fixed{
        display: -webkit-box;
        display: flex;
        -webkit-box-pack: justify;
        justify-content: space-between;
        -webkit-box-align: center;
        align-items: center;
        flex-wrap: wrap;
        flex-basis: 10%;
    }
</style>
